org @
.game_start
di
ld bc,#bc01
out (c),c
ld bc,#bd00
out (c),c

ld hl,unlock
ld bc,#bc11
.unlocklp
ld a,(hl)
inc hl
out (c),a
dec c
jr nz,unlocklp

ld bc,asic_off
out (c),c

ld hl,main_start
ld de,code_start
ld bc,end - code_start
ldir

ld de,#dc00
ld bc,end2 - #dc00
ldir

ld de,#e400
ld bc,end3 - #e400
ldir

ld de,#ec00
ld bc,end4 - #ec00
ldir
ld hl,#4000
ld de,#4001
ld bc,game_start - #4001
ld (hl),l
ldir
ld hl,end_init
ld de,end_init + 1
ld bc,#dc00 - end_init - 1
ld (hl),0
ldir
ld sp,stack_base
ld bc,#7f8d
out (c),c
ld hl,cregs + #0c
ld bc,#bc0d
.crloop
out (c),c
ld a,(hl)
dec hl
inc b
out (c),a
dec b
dec c
jr nz,crloop

ld hl,hwsprites
ld d,#c0
ld a,(hl)
.next_conv
inc hl
ld c,(hl)
inc hl
push hl
call conv_spr
inc d
ld a,d
and 7
cp 6
jr nz,dok
inc d:inc d
.dok
pop hl
ld a,(hl)
or a
jr nz,next_conv

ld hl,#c000
ld d,#e0
ld b,2
.flip_lp
call flipxy
call flipxy
call flipx
call flipx
ld h,#c8
ld d,#e8
djnz flip_lp

ld h,#d0
ld d,#f0
ld b,6
.flip_lp2
call flipx
djnz flip_lp2

asic on
ld c,a
ld hl,int_table + 1
ld de,split_line
exx
ld a,#80
ld (soft_scroll),a
ld hl,sprite_inks
ld de,#6420
ld bc,32
ldir

ld a,10
ld c,0
ld d,#4c
call conv_spr	; 200 (Fly)
ld a,10
inc d
call conv_spr	; 200 (Blue Frog)
ld a,24
ld c,6
ld d,#48
call conv_spr	; Beaver 1
ld a,41
inc d
call conv_spr	; Beaver 2
ld hl,#4800
inc d
call flipx
call flipx

ld h,#60
ld b,a
call clrmem
ld h,#6c
ld b,#0b
call clrmem
ld hl,#6400
ld b,#20
call clrmem

call stopsound
jp cont_init

.conv_spr	; A = sprite number, D * #100 = destination, C = ink adder
ld l,0
ld e,l
rra:rr l
rra:rr l
and #3f
add sprites / 256
ld h,a
.conv_lp
ld a,(hl)
ld b,a:rra:rra:rra:rl b:rla:and 3
jr z,zero0
add c
.zero0
ld (de),a:inc e
ld a,(hl)
ld b,a:rra:rra:rl b:rl b:rla:and 3
jr z,zero1
add c
.zero1
ld (de),a:inc e
ld a,(hl)
ld b,a:rra:rl b:rl b:rl b:rla:and 3
jr z,zero2
add c
.zero2
ld (de),a:inc e
ld a,(hl):inc l
ld b,a:rla:rla:rla:rla:rl b:ld a,b:and 3
jr z,zero3
add c
.zero3
ld (de),a:inc e
jr nz,conv_lp
ret

.flipx		; From HL to D * #100
ld c,16
ld a,e
.flipx_lp
add c
ld e,a
.flipx_inner
dec e
ld a,(hl)
inc l
ld (de),a
ld a,e
and #f
jr nz,flipx_inner
ld a,e
add c
jr nz,flipx_lp
ld e,a
inc d:inc h
ret

.flipxy		; From HL to D * #100
ld e,0
.flipxy_lp
dec l
ld a,(hl)
ld (de),a
inc e
jr nz,flipxy_lp
inc d:inc h
ret

.cregs
db #00,#29,#8e,#26,#00,#20,#22,#00,#07,#00,#00,#23,#ff

.unlock
db #FF,#00,#FF,#77,#B3,#51,#A8,#D4,#62,#39,#9C,#46,#2B,#15,#8A,#CD,#EE

.hwsprites
db 15,0, 13,0, 18,0, 16,0		; Green frogs (C0,C1,C2,C3)
db 19,9, 42,9				; Drowning 1, Blowing 1 (C4,C5)
db 15,12, 13,12, 18,12, 16,12		; Blue frogs (C8,C9,CA,CB)
db 20,9, 43,9				; Drowning 2, Blowing 2 (CC,CD)
db 29,3, 30,3, 31,3, 32,3, 33,3, 34,3	; Snakes (D0,D1,D2,D3,D4,D5)
db 21,9, 44,9				; Drowning 3, Blowing 3	(D8,D9)
db 45,9, 14,0				; Skull & Crossbones, Extra Up frog (DA,DB)
db 0

.spr_frog_up1 		equ #c0
.spr_frog_up2		equ #c1
.spr_frog_up3		equ #db
.spr_frog_left1		equ #c2
.spr_frog_left2		equ #c3
.spr_frog_down1		equ #e0
.spr_frog_down2		equ #e1
.spr_frog_right1	equ #e2
.spr_frog_right2	equ #e3
.spr_blue_up		equ #c8
.spr_blue_left		equ #ca
.spr_blue_right		equ #ea
.spr_drown1		equ #c4
.spr_drown2		equ #cc
.spr_drown3		equ #d8
.spr_blow1		equ #c5
.spr_blow2		equ #cd
.spr_blow3		equ #d9
.spr_skull		equ #da
.spr_snake		equ #d0
.spr_snake_rev		equ #f0

; Other sprites - C8,C9,CA,CB,E8,E9,EA,EB - Blue frogs
; F0,F1,F2,F3,F4,F5 - Reversed snakes

.cont_init
ld hl,game_start
ld de,game_start + 1
ld bc,this_ldir - game_start - 1
ld (hl),0
.this_ldir
ldir

di
ld b,#f5
.waitnoffb
in a,(c)
rra
jr c,waitnoffb
.waitffb
in a,(c)
rra
jr nc,waitffb
ei
halt
ld hl,#08d9	;exx. ex af,af'
ld (#38),hl
ld a,#2e
ld (raster_int),a
call hide_sprites
ld a,asic_off
ld i,a
ld b,#7f
out (c),a
ld bc,#bc01
out (c),c
ld hl,this_ldir
ld de,this_ldir + 1
ld bc,end_init - this_ldir + 1
ld (hl),0
jp start

.end_init